Hi,

> being a regular user of the combined image I'd like to propose changing
> the  format in order to render it more flexible. The main focus are the
> embedded files: The new format shall be able to embedded numerous files
> and their filenames. Furthermore, the type field shall make the image
> identifiable even if the image name has been mangled.

thanks to some feedback the format was slightly improved: There is room for an 
md5 checksum and the type field is longer.

Here is the updated format:
# Write image header followed by all specified files
# The header is padded to 64k, format is:
#  CE               magic word ("Combined Extended Image") (2 bytes) 
#  <TYPE>           short description of the target device (32 bytes)
#  <NUM FILES>      number of files following the header (2 byte)
#  <file1_name>     name of the first file (20 bytes)
#  <file1_length>   length of the first file encoded as zero padded 8 digit 
hex (8 bytes)
#  <file1_md5>      md5 checksum of the first file (32 bytes)
#  <fileN_name>     name of the Nth file (20 bytes)
#  <fileN_length>   length of the Nth file encoded as zero padded 8 digit hex 
(8 bytes)
#  <fileN_md5>      md5 checksum of the Nth file (32 bytes)

Regards,
Marek
--- a/scripts/combined-ext-image.sh
+++ b/scripts/combined-ext-image.sh
@@ -0,0 +1,54 @@
+#!/bin/sh
+#
+# Copyright (C) 2011 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+# Write image header followed by all specified files
+# The header is padded to 64k, format is:
+#  CE               magic word ("Combined Extended Image") (2 bytes)
+#  <TYPE>           short description of the target device (32 bytes)
+#  <NUM FILES>      number of files following the header (2 byte)
+#  <file1_name>     name of the first file (20 bytes)
+#  <file1_length>   length of the first file encoded as zero padded 8 digit hex (8 bytes)
+#  <file1_md5>      md5 checksum of the first file (32 bytes)
+#  <fileN_name>     name of the Nth file (20 bytes)
+#  <fileN_length>   length of the Nth file encoded as zero padded 8 digit hex (8 bytes)
+#  <fileN_md5>      md5 checksum of the Nth file (32 bytes)
+
+usage() {
+	echo "Usage: $0 <type> <ext filename> <file1> <filename1> [<file2> <filename2> <fileN> <filenameN>]"
+	[ "$IMG_OUT" ] && rm -f "$IMG_OUT"
+	exit 1
+}
+
+[ "$#" -lt 4 ] && usage
+
+IMG_TYPE=$1; shift
+IMG_OUT=$1; shift
+FILE_NUM=$(($# / 2))
+FILES=""
+
+printf "CE%-32s%02x" "$IMG_TYPE" $FILE_NUM > $IMG_OUT
+
+while [ "$#" -gt 1 ]
+   do
+      file=$1
+      filename=$2
+
+      [ ! -f "$file" ] && echo "Not a valid file: $file" && usage
+      FILES="$FILES $file"
+      md5=$(cat "$file" | md5sum -)
+      printf "%-20s%08x%32s" "$filename" $(stat -c "%s" "$file") "${md5%% *}" >> $IMG_OUT
+      shift 2
+   done
+
+[ "$#" -eq 1 ] && echo "Filename not specified: $1" && usage
+
+mv $IMG_OUT $IMG_OUT.tmp
+dd if="$IMG_OUT.tmp" of="$IMG_OUT" bs=65536 conv=sync 2>/dev/null
+rm $IMG_OUT.tmp
+
+cat $FILES >> $IMG_OUT
_______________________________________________
openwrt-devel mailing list
openwrt-devel@lists.openwrt.org
https://lists.openwrt.org/mailman/listinfo/openwrt-devel

Reply via email to